# Uses ticcmd to send and receive data from the Tic over USB.
# Works with either Python 2 or Python 3.
#
# NOTE: The Tic's control mode must be "Serial / I2C / USB".

import subprocess
import sys
import configparser
# import yaml

def ticcmd(*args):
    return subprocess.check_output(['ticcmd'] + list(args))



if __name__ == '__main__':
    assert len(sys.argv) == 2

    config = configparser.ConfigParser()
    config.read('config.cfg')
    gearRatio = float(config['CONVERSION']['gear_ratio'])

    print("gearRatio : " + str(gearRatio))

    argument = str(sys.argv[1])
    angle = float(argument) if argument.isdigit() else 0.0
    steps = int(angle * gearRatio)

    if argument == '-r':
        print('Reset')
        commands = config.items("RESET")
        for key, command in commands:
            inputList = command.split(",")
            argumentList = [word if word != 'NUM' else str(steps) for word in inputList]
            print('ticcmd ', end='')
            print(*argumentList)
            print(ticcmd(*argumentList).decode('UTF-8'))
    else:
        print('Angle : ' + str(angle))
        commands = config.items("ANGLE")
        for key, command in commands:
            inputList = command.split(",")
            argumentList = [word if word != 'NUM' else str(steps) for word in inputList]
            print('ticcmd ', end='')
            print(*argumentList)
            print(ticcmd(*argumentList).decode('UTF-8'))
